.\" $Header: /cvsroot/faces/faces/faces/faces.man,v 1.1.1.1 2002/04/15 20:20:48 richburridge Exp $
.\" tbl faces.man | nroff -man | col -b
.TH FACES 1 "15 January 2002"
.SH NAME
faces \- visual mail, and list face server.
.SH SYNOPSIS
.B "faces
[
.B \-A
] [
.B \-B
.I soundfile
] [
.B \-C
.I audiocmd
] [
.B \-I
] [
.B \-M
] [
.B \-P
] [
.B \-S
.I spooldir
] [
.B \-a
] [
.B \-b
.I background
] [
.B \-bg
.I color
] [
.B \-c
.I columns
] [
.B \-d
.I display
] [
.B \-e
.I program
] [
.B \-f
.I facepath
] [
.B \-fg
.I color
] [
.B \-fn
.I font
] [
.B \-g
.I geometry
] [
.B \-h
.I height
] [
.B \-iconic
] [
.B \-i
] [
.B \-l
.I label
] [
.B \-n
] [
.B \-p
.I period
] [
.B \-rv
] [
.B \-s
.I spoolfile
] [
.B \-t
] [
.B \-u
] [
.B \-v
] [
.B \-w
.I width
]
.SH DESCRIPTION
.I Faces
is a window based tool for visual monitoring lists. Typically it is used to
monitor mail, but it is also capable of running a user supplied program or 
shell script. It contains a graphical interface for Gtk. It has three 
different modes of operation:
.PP
The default (no
.BR \-a 
or
.B \-e
arguments)
will monitor for new mail. By default, only the last ten
messages are displayed. Using the left mouse button it is possible to
toggle the text in the faces window. This will either be the username
or the time the mail message arrived. You can clear this area to the
background pattern by hitting the Delete key
(but see below, under
.BR "set button1clear" ).
The icon shows the image
of the last message to arrive.
.PP
The second choice
.RB ( \-a )
is to monitor the whole of a mail file. The open window will
automatically adjust its size to correctly show the face icons. The
open window options are the username or the timestamp and number of
message from that user. The icon will display the image of the last
message, and a count of the total number of messages in the spool
file or mail folder.
.PP
Finally
you can specify a program or shell script to run
.RB ( \-e ).
The standard output
from this program will be read by the faces program, and the appropriate faces
displayed using the information provided. The format of this face information
is given in the faces manual page.
.PP
There are special displays for no mail, no faces found, no print jobs,
no paper in the printer, and no users logged into a machine.
.SH OPTIONS
.TP 12
.B \-A
Enable audio support (where applicable).
.TP
.BI \-B " soundfile"
The name of the sound file to play instead of making the bell sound. Audio
support has to be enabled.
.TP
.BI \-C " audiocmd"
An alternative command to use to play the audio files. Audio support has be
be enabled.
.TP
.B \-I
Read mail from an IMAP mail server. As 
.I faces 
starts, a popup will be displayed.
The user will need to supply their IMAP server name, and their username and 
password. If this information is valid, 
.I faces 
will connect to that IMAP 
server, and display the faces associated with the user mail as described 
above. Note that faces needs to be build with IMAP support enabled for 
this option to work.
.TP
.B \-M
Used when the user is using a mail reader which is capable of shrinking the
mail spoolfile (Elm and MH mail being two such examples) and the default mail
monitoring facility within
.I faces
adjusts accordingly.
.TP
.B \-P
Read mail from a POP mail server. As 
.I faces 
starts, a popup will be displayed.
The user will need to supply their POP server name, and their username and 
password. If this information is valid, 
.I faces 
will connect to that POP
server, and display the faces associated with the user mail as described 
above. Note that faces needs to be build with POP support enabled for 
this option to work.
.TP
.BI \-S " spooldir"
Specify an alternate mail spool directory. The folder that will be monitored
will then be
.BI spooldir/ username
where
.I username
is the name of the user currently logged in.
.TP
.B \-a
Monitor the whole of the specified mail file. The icon and open window display
the appropriate faces, and dynamically change size as a new check is made and
if the mail file has altered size.
.TP
.BI \-b " background"
X11 bitmap file containing an alternate background pattern. The default is
root grey.
.TP
.BI \-bg " color"
The background pixel color to use.
.TP
.BI \-c " columns"
Number of columns of face images in each row. By default this is 10.
.TP
.BI \-d " display"
The X11 display name to use.
.TP
.BI \-e " program"
Name of the user program to run. This program or shell script will generate
lines which the faces program will read, and then display the appropriate
face images. The format of these input records is described in a later
section.
.TP
.BI \-f " facepath"
If specified, this is a colon-separated list of paths to be searched for
face images.  A null entry in the path will be replaced by the compiled
in default face directory.  If not specified, the directories specified
by the FACEPATH environment variable will be used.  If there is no FACEPATH
environment variable, the default face directory will be searched.
The default face directory is normally
.BR /usr/local/faces .
Note that in previous versions of
.IR faces ,
a -f option added the directory to the search path, which already consisted
of the system default faces. Using the -f option now, supercedes the system
default faces, and you must include a trailing colon in the list of paths,
in order to have them included.
.TP
.BI \-fg " color"
The foreground pixel color to use.
.TP
.BI \-fn " font"
The font to use for displaying face names and timestamps.
.TP
.BI \-g " geometry"
Geometry information to use.
.TP
.BI \-h " height"
The height of each face image in pixels. Note that this is the height of
the area allocated to each image, and not necessarily the height of the
displayed image inside.
.TP
.B \-iconic
Start the
.I faces
.\" be consistent, it's italic everywhere else
program up in iconic form.
.TP
.B \-i
Invert the faces images before displaying them.
.TP
.BI \-l " label"
The label to be used in the title line of the
.I faces
window.
.TP
.B \-n
Do not display the number of messages from this person. The default is to
display, and a count is shown at the bottom right corner of the face for
this person.
.TP
.BI \-p " period"
The period in seconds before the mail spool file or the print queue is
scanned again for new mail. The default is 60 seconds.
.TP
.BI \-rv
Displays the faces in pseudo-reverse video by reversing the
foreground and background colors.
.TP
.BI \-s " spoolfile"
Use an alternate mail spool file to monitor. The default is
.BI /var/spool/mail/ username
where
.I username
is the name of the user currently logged in.
.TP
.B \-t
Do not display a timestamp of the last message from this person. The
default is to display, and a timestamp is shown at the bottom left
corner of the face for this person.
.TP
.B \-u
Do not display the username on the face icon. The default is to display,
and the username will appear over the face icon, when the window is
opened.
.TP
.B \-v
Print the version number of this release of the
.I faces
.\" be consistent, it's italic everywhere else
program.
.TP
.BI \-w " width"
The width of each face image in pixels. Note that this is the width of
the area allocated to each image, and not necessarily the width of the
displayed image inside.
.SH AUDIO SUPPORT
.I Faces
is capable of playing sounds for each user when monitoring for new mail.
Audio support needs to have been compiled in,
and also needs to be enabled, and there must be a face.au file
present for that user (see FACE FORMATS below). A special command is used
to play the sounds. This can be overridden by a command line option or an
X resource.
.SH "FACE FORMATS"
There is a special faces directory containing a multi-level hierarchy,
which by default is
.IR /usr/local/faces .
The first few levels are the machine name, where each part of the machine
name is at a separate level. One level below this is the user name, and one
level below that is the actual face image, which can be stored in four formats.
If the file is named
.I face.xpm
then it is an X11 pixmap file. If it is called
.I face.xbm
then it is an X11 bitmap formatted image.
Multiple formats can be stored
in the same username directory, and the one used will depend upon which
graphics interface is currently being used.
.PP
For example, the
.I face.xbm
file for user
.I joe
at host
.I machine.att.com
would be stored in the hierarchy:
.br
.I /com/att/machine/joe/face.xbm
.PP
It is also possible to store audio files in the faces directory. These files
are called face.au, and should be stored under the appropriate user directory.
.PP
To access the face for the mail name
.I machine.dom.ain!uid
take the result of the first successful open from the following list of files
(where $DIR represents iteration over the list of directories in FACEPATH):
.RS 6
$DIR/ain/dom/machine/uid/iconname
.br
$DIR/ain/dom/uid/iconname
.br
$DIR/ain/uid/iconname
.br
$DIR/MISC/uid/iconname
.br
$DIR/ain/dom/machine/unknown/iconname
.br
$DIR/ain/dom/unknown/iconname
.br
$DIR/ain/unknown/iconname
.br
$DIR/MISC/unknown/iconname
.RE
If the
.B \-f
argument is specified the given directory is searched instead of
.IR /usr/local/faces .
The iconname above, consists of the following choices, in the given order:
.TS
r1 c1 l1 l1 .
Gtk	\-	face.xpm,	face.xbm
.TE
Domain names are fully supported. For example, if mail arrives from
.I foo@a.b.c
then
.I faces
will use the directories
.IR c/b/a ,
.I c/b
and
.I c
for the machine name.
The directory
.I MISC
hold faces for generic users such as
.I root
and
.I uucp.
If the faces directory hierarchy is not found, then a blank face image
will be used.
.PP
Faces information is administered by a pair of ASCII files in the faces
directory that associate related machines and faces. The machine table
.I machine.tab
attaches machines to communities; the line
.RS 6
stard=sunaus
.RE
puts the machine
.I stard
in community
.I sunaus.
The machine table may be used to alias entire communities; the line
.RS 6
wseng.sun.com=eng.sun.com
.RE
will cause the
.I wseng.sun.com
domain to be mapped to the
.I eng.sun.com
community. The people table associates a community/alias pair, with a
real username.
.RS 6
sunaus/rburridge=richb
.RE
causes the alias
.I rburridge
to be translated into the real username
.I richb
for the community
.I sunaus
.PP
Note that you still need to use
.I mailtool
or some other mail reading utility to actually read the mail that this program
monitors;
.I faces
simply displays who the mail is from.
.PP
When new mail arrives,
.I faces
.\" be consistent, it's italic everywhere else
will beep and flash appropriately, depending upon the set parameters in
the user's
faces startup
file.
This is looked for in the user's home directory; first the file
.I .facesrc
is tried, and if that file is not found,
.I .mailrc
is looked for.  The file, if found, will be examined for lines in the
following form:
.TP
.BI "set bell = " number
Give the number of times
.I faces
will ring the bell when new mail arrives.
.TP
.BI "set flash = " number
Give the number of times
.I faces
will flash the window when new mail arrives.
.TP
.B "set raise"
.I faces
will raise the window when new mail arrives.
.TP
.B "set lower"
.I faces
will lower the window when there is no mail left in the monitored spoolfile.
.TP
.B "set button1clear"
For those who liked the behaviour of previous versions of
.IR faces ,
this causes button 1 to clear the window (like typing Delete).
The ``toggling'' function of button 1 is moved to button 2
if this option is set.
If you are using the X11 version, these parameters may be set via your X
resources rather than the faces startup file.
See the
.B "X DEFAULTS"
section for more details.
.PP
If you are using the NeWS version and creating face images of the
.I face.ps
form, then the following points should be noted:
All graphics operations should be performed on the unit square; and
the final image will be translated to a 64 x 64 square image at
the appropriate position in the faces display.
.PP
If you are using the
.B \-e
option, then the user program or shell script needs to generate a set
of records which are interpreted by the
.I faces
program. The first record should be in the following fixed format, beginning
at column 1:
.RS 6
Cols=mm Rows=nn
.RE
where mm is the size in columns for the faces window and icon, and
nn is the size in rows. A window will be generated with these dimensions.
.PP
This record is followed by the face information records. These records can
have upto six fields, each one TAB separated. As well as providing the
username and hostname, there are four other fields which can be filled in,
which denote what is displayed on the left or the right sides of the bottom
area of each face image in the normal display and the alternate display
(normally selectable by clicking the left mouse button).
.PP
The fields are:
.PP
.RS 6
username
.br
hostname
.br
normal left
.br
normal right
.br
alternate left
.br
alternate right
.RE
.PP
Any of these fields may be left blank. There are also four special usernames,
which will display the appropriate standard icons. These are
.B "NOMAIL, NOPAPER, NOPRINT "
and
.B "NOUSERS."
.PP
There can also be one optional information record for the faces icon display.
This uses the first four of these fields, and if this record is present, it
should be before the Cols record. If not present, then the icon will contain
the same display and text as the last window unformation record.
.SH XFACE SUPPORT
.I Faces
is capable of recognising a compressed face image in the mail message header.
It uses special X-Face: lines to do this. It is very simple to add your
compressed face image to a mail header.
.LP
The following method works for Berkeley Mail (aka /usr/ucb/mail), Open
Windows mailtool and mush. It probably works for others too.
.LP
It is suggested that each user store the compressed image (generated by
.I compface
) in a file called
.I .face
in their home directory. See the compface manual page for more information
on how to generate the compressed face image. The first line should have the
X-Face: prepended; second and subsequent lines should have a preceding tab,
and there should be a trailing blank line. Here is a typical
.I .face file:
.LP
.sp 0.5
.nf
X-Face: *7O.<19S{MCsaxxe=iCc*y5!i:>e,K40m^btp"<`~gNx5>o?eJMzUng=j]%KybY
	\/VaZ/3a4pD%#rGu7D<M$.TDpaDN8#8eJC&^^&Mr]@~}Pa,*F-ePrMg5.}e,,bu
	qROdT{Vzn{!ouXy.&*#V#Q&Zf7a8lX2Kb}"$UT^VhnsJ?){wFU5r+,duO>4@L
.sp 1.5
.fi
Each user should add the line:
.LP
.sp 0.5 
.nf
set sendmail=/usr/local/bin/faces.sendmail
.sp 1.5
.fi 
to their
.I ~/.mailrc
file, where
.I /usr/local/bin
is the directory where your
.I faces
binaries were installed.
.LP 
A similar method exists with the Elm mailer. The user's compressed face
image should be setup in a
.I ~/.face
file, but without the initial "X-Face:", and leading spaces removed from
each line. There is also no trailing blank line. Here's an example:
.LP
.sp 0.5
.nf
*7O.<19S{MCsaxxe=iCc*y5!i:>e,K40m^btp"<`~gNx5>o?eJMzUng=j]%KybY
\/VaZ/3a4pD%#rGu7D<M$.TDpaDN8#8eJC&^^&Mr]@~}Pa,*F-ePrMg5.}e,,bu
qROdT{Vzn{!ouXy.&*#V#Q&Zf7a8lX2Kb}"$UT^VhnsJ?){wFU5r+,duO>4@L
.sp 1.5
.fi 
To automatically include this into a header into an Elm mail message, just
add the following line to your .elm/elmheaders file:
.LP
.sp 0.5
.nf 
X-Face: `cat $HOME/.face`
.sp 1.5
.fi
.SH X DEFAULTS
.PP
The Gtk version of
.I faces
uses the following X resources.
.I Faces
will now initially try to read resources from whatever the environment 
variable 
.B FACESDEFAULTS
points to. If that's not set, it will try to read resources from
.B $HOME/.facesdefaults
.TP 4
.B audioCommand
The name of the command to use to play audio files.
.PP
.TP 4
.B audioSupport
Enable audio support (where applicable).
.PP
.TP 4
.B background
The window's background color.
The default value is \fIwhite\fP.
.PP
.TP 4
.B backgroundPixmap
The pixel map to use for tiling the background of the faces window or icon.
The default value is the default X11 root background pattern.
.PP
.TP 4
.B bell
The number of times to ring the bell when new mail arrives.
.PP
.TP 4
.B bellAudioFile
The name of an audio file to play instead of sounding the bell.
.PP
.TP 4
.B button1clear
A boolean (default: false), if set, causes faces to revert to the
old button behavior, namely, button 1 clears the window, and
button two toggles the display.
.PP
.TP 4
.B displayHostname
A boolean (default: false), if set, causes faces to display the hostname
rather than the username if the icon represents a username rather than a
hostname.
.PP
.TP 4
.B flash
Give the number of times
to flash the window when new mail arrives.
.PP
.TP 4
.B font
The text font.  The default value is \fIfixed\fP.
.PP
.TP 4
.B foreground
The foreground color.  The default value is \fIblack\fP.
.PP
.TP 4 
.B "geometry (class Geometry)
The size and location of the faces window.
.PP
.TP 4 
.B "iconGeometry (class Geometry)
The size and location of the faces window.
.PP
.TP 4
.B imap
Read users mail from an IMAP mail server.
.PP
.TP 4
.B lower
A boolean (default: false), if true causes
.i faces
to lower it's window when there is no mail left in the monitored spoolfile.
.PP
.TP 4
.B pop
Read users mail from a POP mail server.
.PP
.TP 4
.B raise
A boolean (default: false), if true caused
.i faces
to raise it's window when new mail arrives.
.SH "SEE ALSO"
mail(1), elm(1), mush(1), aliases(7).
.SH FILES
.TP 30
.B /var/spool/mail
directory for system mailboxes
.\" this shouldn't be mentioned here, as faces doesn't use it
.\".TP
.\".B /.face
.\"the users compressed face image
.TP
.B $HOME/.facesrc
faces startup file
.TP
.B $HOME/.mailrc
mail startup file (examined if .facesrc
doesn't exist)
.TP
.B /usr/local/faces
main directory containing the face icons.
.TP
.B /usr/local/faces/people.tab
people/file equivalences
.TP
.B /usr/local/faces/machine.tab
machine/community equivalences
.SH ENVIRONMENT VARIABLES
.TP 15
.B DISPLAY
The X11 server to be used by the Gtk faces program to display
the face icons on.
.TP
.B FACEDEFAULTS
Name of the file containing the X resource information for
.I faces.
.TP
.B FACEPATH
A colon separated list of directory paths to search for machine/user
face icons.
.TP
.B HOME
The home directory of the current user.  Used to locate the .facesrc or .mailrc
file.
.TP
.B MAIL
The complete pathname of the mail spool file to monitor.
.SH HISTORY
.I faces
is based on the Bell Labs Edition 8 program
.IR vismon(9) .
This program is not derived from
.I vismon
source.
.SH BUGS
The machine and people table lookup is hopelessly inefficient and
will need to be improved as the faces database gets larger.
.SH AUTHOR
.TS
l r1 l .
Rich Burridge,	(rich.burridge@Sun.COM)
.TE
