
/* $Header: /cvsroot/faces/faces/faces/pop.h,v 1.1.1.1 2002/04/15 20:20:49 richburridge Exp $
 *
 * This module is a massivily modified version of pop_lib.c
 * found in the mutt mailreader.  The origional copyrights read:
 *
 * Copyright (C) 2000 Vsevolod Volkov <vvv@mutt.org.ua>
 * 
 * Mutt is distributed under the FSF GNU General Public Licence.  The
 * complete Mutt sources and program can be found at http://www.mutt.org/.
 *
 * This version is
 *  Copyright (C) 2001-2002  Robert Adams (misterblue@misterblue.com)
 *  All rights reserved.
 *
 *  Permission is given to distribute these sources, as long as the
 *  copyright messages are not removed, and no monies are exchanged. 
 * 
 *  No responsibility is taken for any errors on inaccuracies inherent
 *  either to the comments or the code of this program, but if reported
 *  to me, then an attempt will be made to fix them.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef POP

#ifndef _POP_H
#define _POP_H 1

#include "face_socket.h"

#define POP_PORT 110
#define POP_SSL_PORT 995

/* maximal length of the server response (RFC1939) */
#define POP_CMD_RESPONSE 512

enum {     /* Status */
    POP_NONE = 0,
    POP_CONNECTED,
    POP_DISCONNECTED,
    POP_BYE
};

typedef enum {
    POP_A_SUCCESS = 0,
    POP_A_SOCKET,
    POP_A_FAILURE,
    POP_A_UNAVAIL
} pop_auth_res_t;

typedef struct {
    CONNECTION *conn;
    char* account;
    char* passwd;
    unsigned int status ;
    size_t size;
    char *timestamp;
    char err_msg[POP_CMD_RESPONSE];
} POP_DATA;

/* pop.c */
POP_DATA* build_popdata(char*, int, char*, char*);
int free_popdata(POP_DATA*);

int pop_open_connection (POP_DATA *);
int pop_close_connection(POP_DATA *);
int pop_query_c(POP_DATA *, char*, char*, size_t);
int pop_query(POP_DATA *, char *, size_t);
int pop_get_statinfo(POP_DATA*, long *, long *);
int pop_fetch_data(POP_DATA *, char *, char *, 
                   int (*funct)(char*, void*), void*);

#endif /*POP_H*/

#endif /*POP*/
