
/*  $Header: /cvsroot/faces/faces/faces/textutil.h,v 1.1.1.1 2002/04/15 20:20:49 richburridge Exp $
 *
 *  Definitions and macros for I18N/L10N of strings.
 *  Taken from the support.h file generated by Glade.
 *
 *  Copyright (C) 1990-2002  Rich Burridge, Sun Microsystems Inc.
 *  All rights reserved.
 *
 *  Permission is given to distribute these sources, as long as the
 *  copyright messages are not removed, and no monies are exchanged.
 *
 *  No responsibility is taken for any errors or inaccuracies inherent
 *  either to the comments or the code of this program, but if reported
 *  to me, then an attempt will be made to fix them.
 *
 */

#ifndef _TEXTUTIL_H
#define _TEXTUTIL_H

/* Standard gettext macros. */

#ifdef ENABLE_NLS
#include <libintl.h>
#undef _
#define _(String) dgettext (PACKAGE, String)
#ifdef gettext_noop
#define N_(String) gettext_noop (String)
#else
#define N_(String) (String)
#endif
#else
#define textdomain(String) (String)
#define gettext(String) (String)
#define dgettext(Domain,Message) (Message)
#define dcgettext(Domain,Message,Type) (Message)
#define bindtextdomain(Domain,Directory) (Domain)
#define _(String) (String)
#define N_(String) (String)
#endif /*ENABLE_NLS*/

#endif  /* _TEXTUTIL_H */
